/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ru.karelia.cs.petrsugen.application;

import java.io.InputStream;
import java.util.List;

import org.mindswap.pellet.jena.PelletReasonerFactory;


import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.util.FileManager;

//import fi.abo.diem.codegen.framework.SimpleModelImplementator;
import java.io.IOException;
import java.util.Set;
import ru.karelia.cs.petrsugen.framework.SimpleModelImplementator;
import ru.karelia.cs.petrsugen.util.Logger;

/**
 *
 * 
 */
public class Generator {

    Logger log;

    public void runGenerator(Logger log, List<String> inputFiles, String outputPath,
            String triplestore, String testProgram, String mainFile, String makeFile, String doxyFile,
            String handlerType, String outputName,
            Set<String> filterIRI) {

        this.log = log;
        log.info("Code Generator started.");

        //Do stuff
        InputStream in = null;

        AppConfiguration.init();

        if (outputName == null) {
            AppConfiguration.setDefaultInputFile(inputFiles.get(0));
        } else {
            AppConfiguration.setDefaultInputFile(outputName);
        }

        AppConfiguration.setOutputPath(outputPath);

        AppConfiguration.setTripleStore(triplestore);
        AppConfiguration.setTestProgram(testProgram);
        AppConfiguration.setMainFile(mainFile);
        AppConfiguration.setMakeFile(makeFile);
        AppConfiguration.setDoxyFile(doxyFile);

        if (handlerType.equals("CS") == true) {
            AppConfiguration.setHandlerType(AppConfiguration.HandlerType.CS);
            AppConfiguration.setCSHandler(AppConfiguration.CSHandler.REGULAR);
            AppConfiguration.setMakeFile("disabled");
            AppConfiguration.setDoxyFile("disabled");
        }else if (handlerType.equals("CSstatic") == true) {
            AppConfiguration.setHandlerType(AppConfiguration.HandlerType.CS);
            AppConfiguration.setCSHandler(AppConfiguration.CSHandler.STATIC);
            AppConfiguration.setMakeFile("disabled");
            AppConfiguration.setDoxyFile("disabled");

        } else {
            AppConfiguration.setHandlerType(AppConfiguration.HandlerType.C);
        }


        //OntModelSpec spec = new OntModelSpec(OntModelSpec.OWL_DL_MEM);
        // ontology from Jena
        OntModel ontm = ModelFactory.createOntologyModel(PelletReasonerFactory.THE_SPEC);

        for (String file : inputFiles) {
            in = FileManager.get().open(file);
            ontm.read(in, "");

            try {
                in.close();
            } catch (IOException e) {
                log.error("Can't close file (" + file + "): " + e.getMessage());
            }
        }

        // ModelImplementator mi = new ModelImplementator(ontm);
        SimpleModelImplementator mi = new SimpleModelImplementator(ontm, filterIRI, log);
        System.out.println("DONE!");
    }
}
