package ru.karelia.cs.petrsugen.framework;

import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.util.FileUtils;

//import ru.cs.karelia.ru.petrsugen.framework.CCodeModelContainer;
import java.util.Set;
import ru.karelia.cs.petrsugen.application.AppConfiguration;
import ru.karelia.cs.petrsugen.handlers.OntHandler;
import ru.karelia.cs.petrsugen.handlers.CSHandler;
//import fi.abo.diem.codegen.handlers.cHandlers.CModelHandler;
//import fi.abo.diem.codegen.handlers.cHandlers.CTestHandler;
//import fi.abo.diem.codegen.handlers.cHandlers.OntTestHandler;
import ru.karelia.cs.petrsugen.handlers.CSStaticHandler;
import ru.karelia.cs.petrsugen.util.CBuildGenerator;
import ru.karelia.cs.petrsugen.util.Logger;

public class SimpleModelImplementator {
    Logger log;

    public SimpleModelImplementator(OntModel ontm, Set<String> filterIRI, Logger log) {
        this.log = log;

        CCodeModelContainer ccm = new CCodeModelContainer();
        String headerFile = ccm.getHeaderFile();
        String sourceFile = ccm.getSourceFile();
        
//    System.out.println("\n\n" + getClass().getResource("/ru/karelia/cs/petrsugen/templates/OntClassDefine.template").toString() + "\n\n");

        if(AppConfiguration.getHandlerType() == AppConfiguration.HandlerType.C){
            OntHandler.handle(ontm, ccm, filterIRI, log);
        }else if(AppConfiguration.getHandlerType() == AppConfiguration.HandlerType.CS
                && AppConfiguration.getCSHandler() == AppConfiguration.CSHandler.REGULAR){
//            OntHandler.handle(ontm, ccm, log);
            CSHandler.handle(ontm, ccm, filterIRI, log);
        }else if(AppConfiguration.getHandlerType() == AppConfiguration.HandlerType.CS
                && AppConfiguration.getCSHandler() == AppConfiguration.CSHandler.STATIC) {
//            OntHandler.handle(ontm, ccm, log);
            CSStaticHandler.handle(ontm, ccm, filterIRI, log);
        }

    	//ccm.write();
    	//  
    	if (AppConfiguration.getTestProgram().toLowerCase().equals("enabled")){
//        	OntTestHandler.handle(ontm, ccm, log);
        	    	
    	}// else {
    	if (!AppConfiguration.getMakeFile().toLowerCase().equals("disabled")
                && AppConfiguration.getHandlerType() == AppConfiguration.HandlerType.CS == false)

            {
    		System.out.println("Generating Makefile");
    		CBuildGenerator.GenerateMakeFile(sourceFile, headerFile);
		}   	 
        	
    	if (!AppConfiguration.getMainFile().toLowerCase().equals("disabled")){
    		System.out.println("Generating KP template (main)");
    		CBuildGenerator.GenerateMainFile(headerFile);
    	}
        /*
        	if (!AppConfiguration.getMakeFile().toLowerCase().equals("disabled")){
        		System.out.println("Generating Makefile");
        		CBuildGenerator.GenerateMakeFile(sourceFile, headerFile);
        	}*/
        
        //}
        ccm.write();

       // ccm.writeTestProgram();
    	if (!AppConfiguration.getDoxyFile().toLowerCase().equals("disabled")){
//    		System.out.println("Generating Doxyfile");
//    		CBuildGenerator.GenerateDoxyFile(headerFile);        
    	}
    
//        CBuildGenerator.GenerateMediator();
        
        log.writeFile(AppConfiguration.getOutputPath()+"generator.log");
    }
}
