package ru.karelia.cs.petrsugen.handlers.cHandlers;

import com.hp.hpl.jena.ontology.OntClass;
import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.ontology.OntProperty;
import com.hp.hpl.jena.util.iterator.ExtendedIterator;

import ru.karelia.cs.petrsugen.framework.CCodeModelContainer;

import ru.karelia.cs.petrsugen.templates.TemplateResourceFile;
import ru.karelia.cs.petrsugen.util.TemplateString;


/**
 *
 *
 */

public class CTestHandler {
	
	static String testProgramTemplate = TemplateResourceFile.getTemplate("CTestProgram");
	static String testCreateIndividualTemplate = TemplateResourceFile.getTemplate("CTestCreateIndividual");
	static String testDPPropertyTemplate = TemplateResourceFile.getTemplate("CTestDPProperty");        	
	static String testIndividualSubscriptionTemplate = TemplateResourceFile.getTemplate("CTestIndividualSubscription");    
	static String testStartSubscriptionTemplate = TemplateResourceFile.getTemplate("CTestStartSubscription");
	
	public static void handle(OntModel model, CCodeModelContainer writer) {
		
		TemplateString testProgram = new TemplateString(testProgramTemplate);
		TemplateString testIndividual = new TemplateString(testCreateIndividualTemplate);
		TemplateString testDPProperty = new TemplateString(testDPPropertyTemplate);
		
		TemplateString testIndividualSubscription = new TemplateString(testIndividualSubscriptionTemplate);
		
		TemplateString testStartSubscription = new TemplateString(testStartSubscriptionTemplate);
		
		testProgram.replaceAll("<@headerfile@>", writer.getHeaderFile());
		
		ExtendedIterator itr = model.listNamedClasses();
		ExtendedIterator dpitr;
		
		while(itr.hasNext()){
			OntClass ontClass = (OntClass) itr.next();
			String className = ontClass.getLocalName().toLowerCase();
			if ((!className.equals("thing")) && (!className.equals("nothing"))) {
				testIndividual.replaceAll("<@classname@>", className);
				testIndividual.replaceAll("<@classindividual@>", "individual_" + className);
				
				testStartSubscription.replaceAll("<@classname@>", className);	
		
				
				testStartSubscription.replaceAll("<@classname@>", className);
				
				testProgram.insertIntoPlaceholder("<%subscriptions%>", testStartSubscription.getString());
				
				testIndividualSubscription.replaceAll("<@classname@>", className);
				
				testProgram.insertIntoPlaceholder("<%subscriptionthreads%>", testIndividualSubscription.getString());
				
				testIndividualSubscription.resetToInitValue();
				testStartSubscription.resetToInitValue();
				dpitr = ontClass.listDeclaredProperties();
				while(dpitr.hasNext()){
		            OntProperty op = (OntProperty) dpitr.next();
		            if (op.isDatatypeProperty()) {
		            	String dpName = op.getLocalName().toLowerCase();
		            	testDPProperty.replaceAll("<@classname@>", className);
		            	testDPProperty.replaceAll("<@classindividual@>", "individual_" + className);						
		            	testDPProperty.replaceAll("<@propertyname@>", dpName);		            	
		            	testIndividual.insertIntoPlaceholder("<%testdps%>", testDPProperty.getString());
		            	testDPProperty.resetToInitValue();
		            	
		            }
					
				}
				
				
				testProgram.insertIntoPlaceholder("<%testindividuals%>", testIndividual.getString());
				
				testIndividual.resetToInitValue();
			}
		}
		
		testProgram.removeTags();
		writer.addTests(testProgram.getString());
		
		
		//ExtendedIterator itr = model.listNamedClasses();
		
		/*
		while(itr.hasNext()){
			OntClass ontClass = (OntClass) itr.next();
			String classURI = ontClass.getNameSpace() + ontClass.getLocalName();
			if 		(!ontClass.getLocalName().equalsIgnoreCase("Thing") && 
					(!ontClass.getLocalName().equalsIgnoreCase("Nothing")))
			{
				OntClass subClassOf = null;	
				//System.out.println("class: "+ ontClass.getLocalName());
				ExtendedIterator supitr = ontClass.listSuperClasses();
				while(supitr.hasNext()){
					OntClass superClass = (OntClass) supitr.next();
				//	System.out.println("DONGO: "+sup.getLocalName());
					if ((superClass.getLocalName() != null) &&
						(!superClass.getLocalName().equalsIgnoreCase("Thing") && 
								(!superClass.getLocalName().equalsIgnoreCase("Nothing"))))
						subClassOf = superClass;
						//System.out.println("SUperclass: "+ superClass.getLocalName());
				}
            
				if (subClassOf != null){
					System.out.println("class: "+ ontClass.getLocalName() + " is subclassof" + subClassOf.getLocalName());
					String subClassURI = subClassOf.getNameSpace() + subClassOf.getLocalName();					
					subClassTriple.replaceAll("<@classtype@>", classURI);
					subClassTriple.replaceAll("<@subclasstype@>", subClassURI);
					contents.insertIntoPlaceholder("<%classtriples%>", subClassTriple.getString());
					System.out.println("class i: "+ ontClass.getLocalName());
					
					subClassTriple.resetToInitValue();
				} 
				classTriple.replaceAll("<@classtype@>", classURI);
				
				contents.insertIntoPlaceholder("<%classtriples%>", classTriple.getString());
				System.out.println("class : "+ ontClass.getLocalName());
				classTriple.resetToInitValue();
					

					
			}	
		}
		*/
		
		
		// this loop generates the create_ontology function		
		
		
	    /*
	    contents.removeTags();
	    TemplateString headerHeaderContents = new TemplateString(
				headerHeaderTemplateName);
		
		headerHeaderContents.replaceAll("<@namespace@>", namespace);
		if (AppConfiguration.getTripleStore().toLowerCase().equals("disabled")){
			headerHeaderContents.replaceAll("<@triplestore@>", "");			
		} else {			
			headerHeaderContents.replaceAll("<@triplestore@>", "#define TRIPLESTORE = 1");
		}
		
		
		ExtendedIterator i = model.listObjectProperties();
		if (i.hasNext()){			
			while(i.hasNext()){
		
				ObjectProperty op = (ObjectProperty) i.next();
			
				if (i.hasNext()){
					opEnumDecl.insertIntoPlaceholder("<%objectpropertyname%>", op.getLocalName().toUpperCase() +",\n");
				} else {
					opEnumDecl.insertIntoPlaceholder("<%objectpropertyname%>", op.getLocalName().toUpperCase());
				}
			}
			opEnumDecl.removeTags();
			headerHeaderContents.insertIntoPlaceholder("<%objectpropertyenum%>", opEnumDecl.getString());
		}
			
		
		headerHeaderContents.replaceTag("<@headerfile@>", writer.getHeaderFile());
		headerHeaderContents.removeTags();
		writer.addDef(headerHeaderContents.getString());
		writer.addImpl(contents.getString());	
	
		
		i = model.listNamedClasses();

		while (i.hasNext()) {			
			OntClass oc = (OntClass) i.next();

			boolean hasThing = false;  
			
			ExtendedIterator iterator = oc.listSuperClasses();
			
			OntClass ontClass;
			while (iterator.hasNext()) {
							
				ontClass = (OntClass) iterator.next();		
					
				if (ontClass.getLocalName() != null) {			
					if (ontClass.getLocalName().equals("Thing")) {			
						hasThing = true;
						break;
					}
				}
				
			}
			
			if (oc.getLocalName() != null && (!oc.getLocalName().equalsIgnoreCase("Nothing")) && (hasThing == true)) {				
				CClassHandler.handle(oc, writer);				
						
			}
					
		
		
		
		}
		*/
		
	}

}
