

package ru.karelia.cs.petrsugen.handlers.cHandlers;

import com.hp.hpl.jena.ontology.OntClass;
import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.ontology.OntProperty;
import com.hp.hpl.jena.util.iterator.ExtendedIterator;

import ru.karelia.cs.petrsugen.framework.CCodeModelContainer;

import ru.karelia.cs.petrsugen.templates.TemplateResourceFile;
import ru.karelia.cs.petrsugen.util.Logger;
import ru.karelia.cs.petrsugen.util.TemplateString;


/**
 *
 *
 */

public class OntTestHandler {
	
	static String testProgramTemplate = TemplateResourceFile.getTemplate("OntTestProgram");
	static String testCreateIndividualTemplate = TemplateResourceFile.getTemplate("OntTestCreateIndividual");
	
	public static void handle(OntModel model, CCodeModelContainer writer, Logger log) {
		
		TemplateString testProgram = new TemplateString(testProgramTemplate);
		TemplateString testIndividual = new TemplateString(testCreateIndividualTemplate);
		/*TemplateString testDPProperty = new TemplateString(testDPPropertyTemplate);
		
		TemplateString testIndividualSubscription = new TemplateString(testIndividualSubscriptionTemplate);
		
		TemplateString testStartSubscription = new TemplateString(testStartSubscriptionTemplate);
		*/
		testProgram.replaceAll("<@headerfile@>", writer.getHeaderFile());
		String prefix = "";
		
		
		
		
		ExtendedIterator itr = model.listNamedClasses();
		//ExtendedIterator dpitr;
		
		while(itr.hasNext()){
			OntClass ontClass = (OntClass) itr.next();
			String className = ontClass.getLocalName();
			if ((!className.equals("thing")) && (!className.equals("nothing"))) {
				testIndividual.replaceAll("<@classname@>", className);
				testIndividual.replaceAll("<@prefix@>", prefix);
				/*testIndividual.replaceAll("<@classindividual@>", "individual_" + className);
				
				testStartSubscription.replaceAll("<@classname@>", className);	
		
				
				testStartSubscription.replaceAll("<@classname@>", className);
				
				testProgram.insertIntoPlaceholder("<%subscriptions%>", testStartSubscription.getString());
				
				testIndividualSubscription.replaceAll("<@classname@>", className);
				
				testProgram.insertIntoPlaceholder("<%subscriptionthreads%>", testIndividualSubscription.getString());*/
				/*
				testIndividualSubscription.resetToInitValue();
				testStartSubscription.resetToInitValue();
				dpitr = ontClass.listDeclaredProperties();
				while(dpitr.hasNext()){
		            OntProperty op = (OntProperty) dpitr.next();
		            if (op.isDatatypeProperty()) {
		            	String dpName = op.getLocalName().toLowerCase();
		            	testDPProperty.replaceAll("<@classname@>", className);
		            	testDPProperty.replaceAll("<@classindividual@>", "individual_" + className);						
		            	testDPProperty.replaceAll("<@propertyname@>", dpName);		            	
		            	testIndividual.insertIntoPlaceholder("<%testdps%>", testDPProperty.getString());
		            	testDPProperty.resetToInitValue();
		            	
		            }
					
				}
				
				*/
				testProgram.insertIntoPlaceholder("<%testindividuals%>", testIndividual.getString());
				
				testIndividual.resetToInitValue();
			}
		}
		log.info("Testprogram generated");
		testProgram.removeTags();
		writer.addTests(testProgram.getString());
		
		
		
	}

}
